commit 5883b88cb01c621b01e2931af97d30e7c7e0d288
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Thu May 9 19:53:10 2024 +0530

    PS-9174 Unified behaviour when calling plugin->deinit for all plugins
    
    https://perconadev.atlassian.net/browse/PS-9174
    
    Bug#36317795 mysql/mysql-server@ce036717cb5
    
    This patch unifies plugin's deinit function call to pass valid plugin pointer
    instead of the nullptr for all types of plugin.
    
    Change-Id: I482497bbaff28d5cd31d74d694056a4df6693152

diff --git a/plugin/audit_null/audit_null.c b/plugin/audit_null/audit_null.c
index 3b1075ca31b..81f6eb642e3 100644
--- a/plugin/audit_null/audit_null.c
+++ b/plugin/audit_null/audit_null.c
@@ -221,6 +221,7 @@ static int audit_null_plugin_init(void *arg MY_ATTRIBUTE((unused)))
 
 static int audit_null_plugin_deinit(void *arg MY_ATTRIBUTE((unused)))
 {
+  assert(arg);
   if (g_plugin_installed == TRUE)
   {
     my_free((void *)(g_record_buffer));
diff --git a/sql/handler.cc b/sql/handler.cc
index 9bd2d3e4570..7f1510407fd 100644
--- a/sql/handler.cc
+++ b/sql/handler.cc
@@ -830,7 +830,7 @@ int ha_finalize_handlerton(st_plugin_int *plugin)
       engine plugins.
     */
     DBUG_PRINT("info", ("Deinitializing plugin: '%s'", plugin->name.str));
-    if (plugin->plugin->deinit(NULL))
+    if (plugin->plugin->deinit(plugin))
     {
       DBUG_PRINT("warning", ("Plugin '%s' deinit function returned error.",
                              plugin->name.str));
@@ -990,7 +990,7 @@ err_deinit:
     was successfully called before.
   */
   if (plugin->plugin->deinit)
-    (void) plugin->plugin->deinit(NULL);
+    (void) plugin->plugin->deinit(plugin);
           
 err:
   my_free(hton);
diff --git a/sql/sql_audit.cc b/sql/sql_audit.cc
index 1becd06f4c2..3ca7f8f441a 100644
--- a/sql/sql_audit.cc
+++ b/sql/sql_audit.cc
@@ -1390,7 +1390,7 @@ int finalize_audit_plugin(st_plugin_int *plugin)
 {
   unsigned long event_class_mask[MYSQL_AUDIT_CLASS_MASK_SIZE];
 
-  if (plugin->plugin->deinit && plugin->plugin->deinit(NULL))
+  if (plugin->plugin->deinit && plugin->plugin->deinit(plugin))
   {
     DBUG_PRINT("warning", ("Plugin '%s' deinit function returned error.",
                             plugin->name.str));
diff --git a/sql/sql_show.cc b/sql/sql_show.cc
index 67854471bd4..cf47d243bc9 100644
--- a/sql/sql_show.cc
+++ b/sql/sql_show.cc
@@ -10115,7 +10115,7 @@ int finalize_schema_table(st_plugin_int *plugin)
     if (plugin->plugin->deinit)
     {
       DBUG_PRINT("info", ("Deinitializing plugin: '%s'", plugin->name.str));
-      if (plugin->plugin->deinit(NULL))
+      if (plugin->plugin->deinit(plugin))
       {
         DBUG_PRINT("warning", ("Plugin '%s' deinit function returned error.",
                                plugin->name.str));
diff --git a/storage/example/ha_example.cc b/storage/example/ha_example.cc
index f466f459e62..9077a38c6c8 100644
--- a/storage/example/ha_example.cc
+++ b/storage/example/ha_example.cc
@@ -132,6 +132,16 @@ static int example_init_func(void *p)
 }
 
 
+static int example_deinit_func(void *p)
+{
+  DBUG_ENTER("example_deinit_func");;
+
+  assert(p);
+
+  DBUG_RETURN(0);
+}
+
+
 /**
   @brief
   Example of simple lock controls. The "share" it creates is a
@@ -1058,7 +1068,7 @@ mysql_declare_plugin(example)
   "Example storage engine",
   PLUGIN_LICENSE_GPL,
   example_init_func,                            /* Plugin Init */
-  NULL,                                         /* Plugin Deinit */
+  example_deinit_func,                          /* Plugin Deinit */
   0x0001 /* 0.1 */,
   func_status,                                  /* status variables */
   example_system_variables,                     /* system variables */

